diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/visualizer/visualizer/core.py ns-3.42/src/visualizer/visualizer/core.py
--- ns-3.41/src/visualizer/visualizer/core.py	2024-02-09 14:44:08.561794800 -0800
+++ ns-3.42/src/visualizer/visualizer/core.py	2024-05-29 15:29:47.188073900 -0700
@@ -253,8 +253,8 @@
         self.visualizer.simulation.lock.acquire()
         try:
             ns3_node = ns.NodeList.GetNode(self.node_index)
-            ipv4 = ns.cppyy.gbl.getNodeIpv4(ns3_node)
-            ipv6 = ns.cppyy.gbl.getNodeIpv6(ns3_node)
+            ipv4 = ns3_node.GetObject[ns.Ipv4]().__deref__()
+            ipv6 = ns3_node.GetObject[ns.Ipv6]().__deref__()
 
             name = "<b><u>Node %i</u></b>" % self.node_index
             node_name = ns.Names.FindName(ns3_node)
@@ -266,12 +266,10 @@
 
             self.emit("query-extra-tooltip-info", lines)
 
-            mob = ns.cppyy.gbl.hasMobilityModel(ns3_node)
+            mob = ns3_node.GetObject[ns.MobilityModel]()
             if mob:
-                mobility_model_name = ns.cppyy.gbl.getMobilityModelName(ns3_node)
-                lines.append(
-                    "  <b>Mobility Model</b>: %s" % ns.cppyy.gbl.getMobilityModelName(ns3_node)
-                )
+                mobility_model_name = mob.__deref__().GetInstanceTypeId().GetName()
+                lines.append("  <b>Mobility Model</b>: %s" % mobility_model_name)
 
             for devI in range(ns3_node.GetNDevices()):
                 lines.append("")
@@ -554,7 +552,7 @@
         """
         if self._has_mobility is None:
             node = ns.NodeList.GetNode(self.node_index)
-            self._has_mobility = ns.cppyy.gbl.hasMobilityModel(node)
+            self._has_mobility = node.GetObject[ns.MobilityModel]()
         return self._has_mobility
 
 
@@ -1214,10 +1212,10 @@
             node_name = "Node %i" % nodeI
             node_view = self.get_node(nodeI)
 
-            mobility = ns.cppyy.gbl.hasMobilityModel(node)
+            mobility = node.GetObject[ns.MobilityModel]()
             if mobility:
                 node_view.set_color("red")
-                pos = ns.cppyy.gbl.getNodePosition(node)
+                pos = node.GetObject[ns.MobilityModel]().__deref__().GetPosition()
                 node_view.set_position(*transform_point_simulation_to_canvas(pos.x, pos.y))
                 # print "node has mobility position -> ", "%f,%f" % (pos.x, pos.y)
             else:
@@ -1323,9 +1321,9 @@
         for node in self.nodes.values():
             if node.has_mobility:
                 ns3_node = ns.NodeList.GetNode(node.node_index)
-                mobility = ns.cppyy.gbl.hasMobilityModel(ns3_node)
+                mobility = ns3_node.GetObject[ns.MobilityModel]()
                 if mobility:
-                    pos = ns.cppyy.gbl.getNodePosition(ns3_node)
+                    pos = ns3_node.GetObject[ns.MobilityModel]().__deref__().GetPosition()
                     x, y = transform_point_simulation_to_canvas(pos.x, pos.y)
                     node.set_position(x, y)
                     if node is self.follow_node:
@@ -1724,12 +1722,12 @@
         self.simulation.lock.acquire()
         try:
             ns3_node = ns.NodeList.GetNode(node.node_index)
-            mob = ns.cppyy.gbl.hasMobilityModel(ns3_node)
+            mob = ns3_node.GetObject[ns.MobilityModel]()
             if not mob:
                 return
             if self.node_drag_state is not None:
                 return
-            pos = ns.cppyy.gbl.getNodePosition(ns3_node)
+            pos = ns3_node.GetObject[ns.MobilityModel]().__deref__().GetPosition()
         finally:
             self.simulation.lock.release()
         devpos = self.canvas.get_window().get_device_position(event.device)
@@ -1743,7 +1741,7 @@
         self.simulation.lock.acquire()
         try:
             ns3_node = ns.NodeList.GetNode(node.node_index)
-            mob = ns.cppyy.gbl.hasMobilityModel(ns3_node)
+            mob = ns3_node.GetObject[ns.MobilityModel]()
             if not mob:
                 return False
             if self.node_drag_state is None:
@@ -1984,7 +1982,14 @@
     add_initialization_hook(hook)
 
 
+_run_once = False
+
+
 def start():
+    global _run_once
+    if _run_once:
+        return
+    _run_once = True
     assert Visualizer.INSTANCE is None
     if _import_error is not None:
         import sys
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/visualizer/visualizer/__init__.py ns-3.42/src/visualizer/visualizer/__init__.py
--- ns-3.41/src/visualizer/visualizer/__init__.py	2024-02-09 14:44:08.561794800 -0800
+++ ns-3.42/src/visualizer/visualizer/__init__.py	2024-05-29 15:29:47.188073900 -0700
@@ -1,28 +1,3 @@
 from ns import *
 
-# Some useful tricks for visualizer
-# we need to check if the node has a mobility model, but we can't pass Ptr<MobilityModel> to python
-ns.cppyy.cppdef(
-    """using namespace ns3; bool hasMobilityModel(Ptr<Node> node){ return !(node->GetObject<MobilityModel>() == 0); };"""
-)
-ns.cppyy.cppdef(
-    """using namespace ns3; Vector3D getNodePosition(Ptr<Node> node){ return node->GetObject<MobilityModel>()->GetPosition(); };"""
-)
-ns.cppyy.cppdef(
-    """using namespace ns3; Ptr<Ipv4> getNodeIpv4(Ptr<Node> node){ return node->GetObject<Ipv4>(); };"""
-)
-ns.cppyy.cppdef(
-    """using namespace ns3; Ptr<Ipv6> getNodeIpv6(Ptr<Node> node){ return node->GetObject<Ipv6>(); };"""
-)
-ns.cppyy.cppdef(
-    """using namespace ns3; std::string getMobilityModelName(Ptr<Node> node){ return node->GetObject<MobilityModel>()->GetInstanceTypeId().GetName(); };"""
-)
-ns.cppyy.cppdef(
-    """using namespace ns3; bool hasOlsr(Ptr<Node> node){ return !(node->GetObject<olsr::RoutingProtocol>() == 0); };"""
-)
-ns.cppyy.cppdef(
-    """using namespace ns3; Ptr<olsr::RoutingProtocol> getNodeOlsr(Ptr<Node> node){ return node->GetObject<olsr::RoutingProtocol>(); };"""
-)
-
-
 from .core import add_initialization_hook, register_plugin, set_bounds, start
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/visualizer/visualizer/plugins/ipv4_routing_table.py ns-3.42/src/visualizer/visualizer/plugins/ipv4_routing_table.py
--- ns-3.41/src/visualizer/visualizer/plugins/ipv4_routing_table.py	2024-02-09 14:44:08.561794800 -0800
+++ ns-3.42/src/visualizer/visualizer/plugins/ipv4_routing_table.py	2024-05-29 15:29:47.188073900 -0700
@@ -110,7 +110,7 @@
         @return none
         """
         node = ns.NodeList.GetNode(self.node_index)
-        ipv4 = ns.cppyy.gbl.getNodeIpv4(node)
+        ipv4 = node.GetObject[ns.Ipv4]().__deref__()
         routing = ipv4.GetRoutingProtocol()
         if routing is None:
             return
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/visualizer/visualizer/plugins/olsr.py ns-3.42/src/visualizer/visualizer/plugins/olsr.py
--- ns-3.41/src/visualizer/visualizer/plugins/olsr.py	2024-02-09 14:44:08.561794800 -0800
+++ ns-3.42/src/visualizer/visualizer/plugins/olsr.py	2024-05-29 15:29:47.188073900 -0700
@@ -104,12 +104,12 @@
         """
         node = ns.NodeList.GetNode(self.node_index)
         ipv4 = node.GetObject(ns.Ipv4.GetTypeId())
-        if not ns.cppyy.gbl.hasOlsr(ns3_node):
+        olsr = ns3_node.GetObject[ns.olsr.RoutingProtocol]()
+        if not olsr:
             return
-        olsr = ns.cppyy.gbl.getNodeOlsr(node)
 
         self.table_model.clear()
-        for route in olsr.GetRoutingTableEntries():
+        for route in olsr.__deref__().GetRoutingTableEntries():
             tree_iter = self.table_model.append()
             netdevice = ipv4.GetNetDevice(route.interface)
             if netdevice is None:
@@ -133,7 +133,7 @@
 
 def populate_node_menu(viz, node, menu):
     ns3_node = ns.NodeList.GetNode(node.node_index)
-    if not ns.cppyy.gbl.hasOlsr(ns3_node):
+    if not ns3_node.GetObject[ns.olsr.RoutingProtocol]():
         print("No OLSR")
         return
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/visualizer/visualizer/plugins/show_last_packets.py ns-3.42/src/visualizer/visualizer/plugins/show_last_packets.py
--- ns-3.41/src/visualizer/visualizer/plugins/show_last_packets.py	2024-02-09 14:44:08.561794800 -0800
+++ ns-3.42/src/visualizer/visualizer/plugins/show_last_packets.py	2024-05-29 15:29:47.188073900 -0700
@@ -106,7 +106,7 @@
                 if sample.device is None:
                     interface_name = "(unknown)"
                 else:
-                    interface_name = ns.core.Names.FindName(sample.device)
+                    interface_name = ns.Names.FindName(sample.device)
                     if not interface_name:
                         interface_name = "(interface %i)" % sample.device.GetIfIndex()
                 self.table_model.set(
@@ -138,7 +138,7 @@
         self.win.set_title("Last packets for node %i" % node_index)
         self.visualizer = visualizer
         self.viz_node = visualizer.get_node(node_index)
-        self.node = ns.network.NodeList.GetNode(node_index)
+        self.node = ns.NodeList.GetNode(node_index)
 
         def smart_expand(expander, vbox):
             if expander.get_expanded():
@@ -184,7 +184,7 @@
         # Packet Filter
 
         # - options
-        self.packet_capture_options = ns.visualizer.PyViz.PacketCaptureOptions()
+        self.packet_capture_options = ns.PyViz.PacketCaptureOptions()
         self.packet_capture_options.numLastPackets = 100
 
         packet_filter_vbox = Gtk.VBox(False, 4)
@@ -214,10 +214,10 @@
 
         self.packet_filter_list = []  # list of TypeIdConfig instances
 
-        Header = ns.core.TypeId.LookupByName("ns3::Header")
-        Trailer = ns.core.TypeId.LookupByName("ns3::Trailer")
-        for typeid_i in range(ns.core.TypeId.GetRegisteredN()):
-            typeid = ns.core.TypeId.GetRegistered(typeid_i)
+        Header = ns.TypeId.LookupByName("ns3::Header")
+        Trailer = ns.TypeId.LookupByName("ns3::Trailer")
+        for typeid_i in range(ns.TypeId.GetRegisteredN()):
+            typeid = ns.TypeId.GetRegistered(typeid_i)
             # check if this is a header or trailer subtype
             typeid_tmp = typeid
             type_is_good = False
@@ -242,13 +242,9 @@
 
         def update_capture_options():
             if self.op_AND_button.props.active:
-                self.packet_capture_options.mode = (
-                    ns.visualizer.PyViz.PACKET_CAPTURE_FILTER_HEADERS_AND
-                )
+                self.packet_capture_options.mode = ns.PyViz.PACKET_CAPTURE_FILTER_HEADERS_AND
             else:
-                self.packet_capture_options.mode = (
-                    ns.visualizer.PyViz.PACKET_CAPTURE_FILTER_HEADERS_OR
-                )
+                self.packet_capture_options.mode = ns.PyViz.PACKET_CAPTURE_FILTER_HEADERS_OR
             self.packet_capture_options.numLastPackets = 100
             self.packet_capture_options.headers = [
                 c.typeid for c in self.packet_filter_list if c.selected
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/visualizer/visualizer/plugins/wifi_intrastructure_link.py ns-3.42/src/visualizer/visualizer/plugins/wifi_intrastructure_link.py
--- ns-3.41/src/visualizer/visualizer/plugins/wifi_intrastructure_link.py	2024-02-09 14:44:08.561794800 -0800
+++ ns-3.42/src/visualizer/visualizer/plugins/wifi_intrastructure_link.py	2024-05-29 15:29:47.188073900 -0700
@@ -151,17 +151,17 @@
         self.stations = []
 
         for node in viz.nodes.values():
-            ns3_node = ns.network.NodeList.GetNode(node.node_index)
+            ns3_node = ns.NodeList.GetNode(node.node_index)
             for devI in range(ns3_node.GetNDevices()):
                 dev = ns3_node.GetDevice(devI)
-                if not isinstance(dev, ns.wifi.WifiNetDevice):
+                if not isinstance(dev, ns.WifiNetDevice):
                     continue
                 wifi_mac = dev.GetMac()
-                if isinstance(wifi_mac, ns.wifi.StaWifiMac):
+                if isinstance(wifi_mac, ns.StaWifiMac):
                     wifi_link = WifiLink(viz.links_group, node, dev)
                     self.stations.append((dev, node, wifi_link))
-                elif isinstance(wifi_mac, ns.wifi.ApWifiMac):
-                    bssid = ns.network.Mac48Address.ConvertFrom(dev.GetAddress())
+                elif isinstance(wifi_mac, ns.ApWifiMac):
+                    bssid = ns.Mac48Address.ConvertFrom(dev.GetAddress())
                     self.access_points[str(bssid)] = node
         # print "APs: ", self.access_points
         # print "STAs: ", self.stations
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/CMakeLists.txt ns-3.42/src/wifi/CMakeLists.txt
--- ns-3.41/src/wifi/CMakeLists.txt	2024-02-09 14:44:08.561794800 -0800
+++ ns-3.42/src/wifi/CMakeLists.txt	2024-05-29 15:29:47.188073900 -0700
@@ -12,6 +12,7 @@
     helper/wifi-mac-helper.cc
     helper/wifi-radio-energy-model-helper.cc
     helper/yans-wifi-helper.cc
+    helper/wifi-phy-rx-trace-helper.cc
     model/addba-extension.cc
     model/adhoc-wifi-mac.cc
     model/ampdu-subframe-header.cc
@@ -42,6 +43,7 @@
     model/frame-capture-model.cc
     model/frame-exchange-manager.cc
     model/he/constant-obss-pd-algorithm.cc
+    model/he/he-6ghz-band-capabilities.cc
     model/he/he-capabilities.cc
     model/he/he-configuration.cc
     model/he/he-frame-exchange-manager.cc
@@ -101,6 +103,7 @@
     model/rate-control/thompson-sampling-wifi-manager.cc
     model/recipient-block-ack-agreement.cc
     model/reduced-neighbor-report.cc
+    model/reference/error-rate-tables.cc
     model/simple-frame-capture-model.cc
     model/snr-tag.cc
     model/spectrum-wifi-phy.cc
@@ -110,6 +113,7 @@
     model/supported-rates.cc
     model/table-based-error-rate-model.cc
     model/threshold-preamble-detection-model.cc
+    model/tim.cc
     model/txop.cc
     model/vht/vht-capabilities.cc
     model/vht/vht-configuration.cc
@@ -148,6 +152,7 @@
     model/wifi-remote-station-manager.cc
     model/wifi-spectrum-phy-interface.cc
     model/wifi-spectrum-signal-parameters.cc
+    model/wifi-standards.cc
     model/wifi-tx-current-model.cc
     model/wifi-tx-parameters.cc
     model/wifi-tx-timer.cc
@@ -156,6 +161,7 @@
     model/yans-error-rate-model.cc
     model/yans-wifi-channel.cc
     model/yans-wifi-phy.cc
+    model/wifi-spectrum-value-helper.cc
 )
 
 set(header_files
@@ -165,6 +171,7 @@
     helper/wifi-mac-helper.h
     helper/wifi-radio-energy-model-helper.h
     helper/yans-wifi-helper.h
+    helper/wifi-phy-rx-trace-helper.h
     model/addba-extension.h
     model/adhoc-wifi-mac.h
     model/ampdu-subframe-header.h
@@ -195,6 +202,7 @@
     model/frame-capture-model.h
     model/frame-exchange-manager.h
     model/he/constant-obss-pd-algorithm.h
+    model/he/he-6ghz-band-capabilities.h
     model/he/he-capabilities.h
     model/he/he-configuration.h
     model/he/he-frame-exchange-manager.h
@@ -264,6 +272,7 @@
     model/supported-rates.h
     model/table-based-error-rate-model.h
     model/threshold-preamble-detection-model.h
+    model/tim.h
     model/txop.h
     model/vht/vht-capabilities.h
     model/vht/vht-configuration.h
@@ -292,6 +301,7 @@
     model/wifi-mpdu-type.h
     model/wifi-mpdu.h
     model/wifi-net-device.h
+    model/wifi-opt-field.h
     model/wifi-phy-band.h
     model/wifi-phy-common.h
     model/wifi-phy-listener.h
@@ -317,6 +327,7 @@
     model/yans-error-rate-model.h
     model/yans-wifi-channel.h
     model/yans-wifi-phy.h
+    model/wifi-spectrum-value-helper.h
 )
 
 build_lib(
@@ -332,6 +343,7 @@
     test/channel-access-manager-test.cc
     test/inter-bss-test-suite.cc
     test/power-rate-adaptation-test.cc
+    test/power-save-test.cc
     test/spectrum-wifi-phy-test.cc
     test/tx-duration-test.cc
     test/wifi-aggregation-test.cc
@@ -339,12 +351,15 @@
     test/wifi-eht-info-elems-test.cc
     test/wifi-emlsr-test.cc
     test/wifi-error-rate-models-test.cc
+    test/wifi-fils-frame-test.cc
+    test/wifi-he-info-elems-test.cc
     test/wifi-ie-fragment-test.cc
     test/wifi-mac-ofdma-test.cc
     test/wifi-mac-queue-test.cc
     test/wifi-mlo-test.cc
     test/wifi-phy-ofdma-test.cc
     test/wifi-phy-reception-test.cc
+    test/wifi-phy-rx-trace-helper-test.cc
     test/wifi-phy-thresholds-test.cc
     test/wifi-primary-channels-test.cc
     test/wifi-ru-allocation-test.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/doc/Makefile ns-3.42/src/wifi/doc/Makefile
--- ns-3.41/src/wifi/doc/Makefile	2024-02-09 14:44:08.561794800 -0800
+++ ns-3.42/src/wifi/doc/Makefile	2024-05-29 15:29:47.188073900 -0700
@@ -13,7 +13,8 @@
 	$(FIGURES)/WifiArchitecture.dia \
 	$(FIGURES)/PhyEntityHierarchy.dia \
 	$(FIGURES)/WifiPpduHierarchy.dia \
-	$(FIGURES)/FemHierarchy.dia
+	$(FIGURES)/FemHierarchy.dia \
+	$(FIGURES)/wifi-phy-rx-trace-helper.dia
 
 # specify eps figures from which .png and .pdf figures need to be built
 
@@ -23,6 +24,7 @@
 	$(FIGURES)/PhyEntityHierarchy.eps \
 	$(FIGURES)/WifiPpduHierarchy.eps \
 	$(FIGURES)/FemHierarchy.eps \
+	$(FIGURES)/wifi-phy-rx-trace-helper.eps \
         $(FIGURES)/assoc-manager.eps \
         $(FIGURES)/clear-channel.eps \
         $(FIGURES)/emlsr-dl-txop.eps \
@@ -63,7 +65,7 @@
 
 
 # You can set these variables from the command line.
-SPHINXOPTS    =
+SPHINXOPTS    = -W --keep-going
 SPHINXBUILD   = sphinx-build
 PAPER         =
 BUILDDIR      = build
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/examples/CMakeLists.txt ns-3.42/src/wifi/examples/CMakeLists.txt
--- ns-3.41/src/wifi/examples/CMakeLists.txt	2024-02-09 14:44:08.573794800 -0800
+++ ns-3.42/src/wifi/examples/CMakeLists.txt	2024-05-29 15:29:47.196073800 -0700
@@ -57,3 +57,12 @@
     ${libapplications}
     ${libinternet-apps}
 )
+
+build_lib_example(
+  NAME wifi-phy-rx-trace-example
+  SOURCE_FILES wifi-phy-rx-trace-example.cc
+  LIBRARIES_TO_LINK
+    ${libwifi}
+    ${libinternet}
+    ${libmobility}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/examples/wifi-bianchi.cc ns-3.42/src/wifi/examples/wifi-bianchi.cc
--- ns-3.41/src/wifi/examples/wifi-bianchi.cc	2024-02-09 14:44:08.573794800 -0800
+++ ns-3.42/src/wifi/examples/wifi-bianchi.cc	2024-05-29 15:29:47.196073800 -0700
@@ -53,6 +53,7 @@
 #include "ns3/yans-wifi-helper.h"
 
 #include <fstream>
+#include <vector>
 
 /// Avoid std::numbers::pi because it's C++20
 #define PI 3.1415926535
@@ -2166,6 +2167,8 @@
     case OBSS_PD_CCA_RESET:
         NS_FATAL_ERROR("Unexpected CCA reset!");
         break;
+    case SIGNAL_DETECTION_ABORTED_BY_TX:
+        break;
     case UNKNOWN:
     default:
         NS_FATAL_ERROR("Unknown drop reason!");
@@ -2866,11 +2869,7 @@
     }
     else if (standard == "11n")
     {
-        if (frequency == 2.4)
-        {
-            wifiStandard = WIFI_STANDARD_80211n;
-        }
-        else if (frequency == 5)
+        if (frequency == 2.4 || frequency == 5)
         {
             wifiStandard = WIFI_STANDARD_80211n;
         }
@@ -2887,15 +2886,7 @@
     }
     else if (standard == "11ax")
     {
-        if (frequency == 2.4)
-        {
-            wifiStandard = WIFI_STANDARD_80211ax;
-        }
-        else if (frequency == 5)
-        {
-            wifiStandard = WIFI_STANDARD_80211ax;
-        }
-        else if (frequency == 6)
+        if (frequency == 2.4 || frequency == 5 || frequency == 6)
         {
             wifiStandard = WIFI_STANDARD_80211ax;
         }
@@ -2972,7 +2963,7 @@
     Experiment experiment;
     WifiMacHelper wifiMac;
     double averageThroughput;
-    double throughputArray[trials];
+    std::vector<double> throughputArray(trials);
     for (uint32_t n = nMinStas; n <= nMaxStas; n += nStepSize)
     {
         averageThroughput = 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/examples/wifi-manager-example.cc ns-3.42/src/wifi/examples/wifi-manager-example.cc
--- ns-3.41/src/wifi/examples/wifi-manager-example.cc	2024-02-09 14:44:08.573794800 -0800
+++ ns-3.42/src/wifi/examples/wifi-manager-example.cc	2024-05-29 15:29:47.196073800 -0700
@@ -65,6 +65,7 @@
 #include "ns3/ssid.h"
 #include "ns3/tuple.h"
 #include "ns3/uinteger.h"
+#include "ns3/wifi-mac.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/yans-wifi-helper.h"
 
@@ -230,6 +231,9 @@
     uint32_t maxSlrc = 7;
     uint32_t maxSsrc = 7;
 
+    RngSeedManager::SetSeed(1);
+    RngSeedManager::SetRun(2);
+
     CommandLine cmd(__FILE__);
     cmd.AddValue("maxSsrc",
                  "The maximum number of retransmission attempts for a RTS packet",
@@ -673,10 +677,8 @@
         clientDevice = wifi.Install(wifiPhy, wifiMac, clientNode);
     }
 
-    RngSeedManager::SetSeed(1);
-    RngSeedManager::SetRun(2);
     wifi.AssignStreams(serverDevice, 100);
-    wifi.AssignStreams(clientDevice, 100);
+    wifi.AssignStreams(clientDevice, 200);
 
     Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/BE_MaxAmpduSize",
                 UintegerValue(maxAmpduSize));
@@ -798,6 +800,16 @@
 
     Simulator::Stop(Seconds((steps + 1) * stepTime));
     Simulator::Run();
+
+    if (serverSelectedStandard.m_standard >= WIFI_STANDARD_80211n)
+    {
+        NS_ABORT_MSG_UNLESS(wndClient->GetMac()->GetBaAgreementEstablishedAsOriginator(
+                                wndServer->GetMac()->GetAddress(),
+                                0),
+                            "Expected BA agreement established for standard "
+                                << serverSelectedStandard.m_standard);
+    }
+
     Simulator::Destroy();
 
     gnuplot.AddDataset(rateDataset);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/examples/wifi-phy-configuration.cc ns-3.42/src/wifi/examples/wifi-phy-configuration.cc
--- ns-3.41/src/wifi/examples/wifi-phy-configuration.cc	2024-02-09 14:44:08.573794800 -0800
+++ ns-3.42/src/wifi/examples/wifi-phy-configuration.cc	2024-05-29 15:29:47.196073800 -0700
@@ -479,4 +479,6 @@
 
     // No need to Simulator::Run (); this is a configuration example
     Simulator::Destroy();
+
+    return 0;
 }
